import * as actions from './actionTypes';

export default load => store => {
  store.dispatch({
    type: actions.STATE_LOADING_START,
  });
  load().then(
    state => {
      store.dispatch({
        type: actions.STATE_LOADING_DONE,
        payload: {state},
      });
    },
    error => {
      store.dispatch({
        type: actions.STATE_LOADING_FAILED,
        payload: {error},
      });
    }
  );
  return next => action => next(action);
};
